#include "AFilemic.h"

extern HINSTANCE hDLLModule;
namespace AFilemic {
    HANDLE AOpen(const char* Name, orm r)
    {
        HANDLE f;
        if (r == rmR)
            f= CreateFileA(Name, GENERIC_READ, FILE_SHARE_READ, NULL,
                OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, NULL);
        else
            f= CreateFileA(Name, GENERIC_WRITE, 0, NULL,
                CREATE_ALWAYS, FILE_FLAG_SEQUENTIAL_SCAN, NULL);
        if (f!=INVALID_HANDLE_VALUE)return f;
        char tempname[1024];
        int fqs = -1;
        int lsl = -1;
        int i;
        for (i = 0; i < 1024; i++) {
            BYTE b = Name[i];
            if (b == '/' || b == '\\') { lsl = i; b = '\\'; }
            else if (b == '?'&&fqs == -1) {
                if(i < 2 || (*(WORD*)(tempname + i - 2) != 0x5c5c || (Name[i + 1] != '\\'&&Name[i + 1] != '/')))fqs = i;
            }
            else if (b == '<' || b == '>' || b == '*' || b == '|' || b>127) {
                b = '?';
                if (fqs==-1)fqs = i;
            }
            tempname[i] = b;
            if (!b)break;
        }


        if (fqs == -1||lsl==-1||lsl==(i-1))return f;

        OPENFILENAMEW ofn;
        WCHAR szFile[1024];
        WCHAR szFileTitle[1024];
        WCHAR szDir[1024];
        WCHAR* szFileFilter = L"*.blp\0";
        ofn.lStructSize = sizeof(OPENFILENAME);
        ofn.hwndOwner = GetActiveWindow();
        ofn.hInstance = hDLLModule;
        ofn.nFilterIndex = 1;
        ofn.lpstrFile = szFile;
        ofn.nMaxFile = sizeof(szFile);
        ofn.lpstrFileTitle = szFileTitle;
        ofn.nMaxFileTitle = sizeof(szFileTitle);
        ofn.lpstrCustomFilter = NULL;
        ofn.nMaxCustFilter = 0;
        ofn.lpstrFilter = szFileFilter;
        ofn.lpstrInitialDir = NULL;
        ofn.lpstrTitle = NULL;
        ofn.lpstrDefExt = NULL;
        ofn.dwReserved = 0;
        ofn.FlagsEx = 0;
        ofn.lpstrDefExt = L"blp";
        
        if (fqs > lsl) {
            MultiByteToWideChar(CP_ACP, 0, tempname, i+1, szFile, 1024);
            WCHAR a;
            for (i = 0; (a = szFile[i])&&i<1024;i++) {
                if (a == L'\\')lsl = i;
                szDir[i] = a;
            }
            szDir[lsl+1] = 0;
            HANDLE ffh;
            WIN32_FIND_DATAW ffd;
            if (r == rmR) {
                ffh = FindFirstFileW(szFile, &ffd);
                if (ffh != INVALID_HANDLE_VALUE) {
                    WIN32_FIND_DATAW ffd1;
                    if (!FindNextFileW(ffh, &ffd1)) {
                        FindClose(ffh);
                        WCHAR* sr = ffd.cFileName;
                        for (i = lsl + 1; i < 1023; i++) { 
                            if(!(szFile[i] = *sr))break; 
                            sr++;
                        }
                        szFile[1023] = 0;
                        return CreateFileW(szFile, GENERIC_READ, FILE_SHARE_READ, NULL,
                            OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, NULL);
                    }
                }
                FindClose(ffh);
            }
            
            ofn.lpstrInitialDir = szDir;
        }


        szFile[0] = 0;
        if (r == rmR) {
            ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
            if (GetOpenFileNameW(&ofn))
                return CreateFileW(szFile, GENERIC_READ, FILE_SHARE_READ, NULL,
                    OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, NULL);
        }
        else {
            ofn.Flags = OFN_HIDEREADONLY | OFN_PATHMUSTEXIST;
            if (GetSaveFileNameW(&ofn))
                return CreateFileW(szFile, GENERIC_WRITE, 0, NULL,
                    CREATE_ALWAYS, FILE_FLAG_SEQUENTIAL_SCAN, NULL);

        }
        return INVALID_HANDLE_VALUE;
    }
    void ARead(BYTE* buf,DWORD count,DWORD offset,HANDLE f)
    {
        if (f != INVALID_HANDLE_VALUE) {
            unsigned long readCount = count;
            SetFilePointer(f, offset, NULL, FILE_BEGIN);
            ReadFile(f, buf, count, &readCount, NULL);
        }
    }
    void AWrite(BYTE* buf, DWORD count, HANDLE f)
    {
        if (f != INVALID_HANDLE_VALUE) {
            unsigned long readCount = count;
            SetFilePointer(f, 0, NULL, FILE_BEGIN);
            WriteFile(f, buf, count, &readCount, NULL);
        }
    }

    void AClose(HANDLE f)
    {
        if (f != INVALID_HANDLE_VALUE){
            FlushFileBuffers(f);
            CloseHandle(f);
        }
    }



}